<?php
/***************************************************************************
 * Xlrstats Webmodule
 * Webfront for XLRstats for B3 (www.bigbrotherbot.com)
 * (c) 2004-2009 www.xlr8or.com (mailto:xlr8or@xlr8or.com)
 ***************************************************************************/

/***************************************************************************
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  http://www.gnu.org/copyleft/gpl.html
 ***************************************************************************/

//**************************************************************************************
//
//  Functions for the general statistics (i.e. not player, weapon or map specific)
//  These are generally used on the "index" page
//
//**************************************************************************************


// Function that prints a table of the best players. The criterium (e.g. skill or kills) can be
// specified.
function topplayers($sortby = "skill", $direction = "DESC", $offset = 0, $clan_name = "")
{
  $link = baselink();

  global $coddb;
  global $minkills;
  global $minrounds;
  global $toplist_max;
  global $t;
  global $maxdays;
  global $separatorline;
  global $MaxKillRatio;
  global $ShowRatioGraph;
  global $geoip_path;

  $current_time = gmdate("U");

  $sortfields = array("kills", "deaths", "ratio", "skill", "rounds", "winstreak", "losestreak");
  $sortby = strtolower($sortby);
  if (! in_array($sortby, $sortfields))
  $sortby = $sortfields[0];
  if ( $direction != "ASC")
    $direction = "DESC";

  if ($clan_name != "")
    echo "<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\" class=\"outertable\"><tr><td align=\"center\">Top $toplist_max - $sortby (Filtered by: $clan_name)</td></tr><tr><td>";
  else
    echo "<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\" class=\"outertable\"><tr><td align=\"center\">Top $toplist_max - $sortby</td></tr><tr><td>";

  echo "
        <table width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"0\" class=\"innertable\">
        <tr class=\"outertable\">
        <td align=\"center\" width=\"40\">Place</td>
        <td align=\"center\" width=\"30\">Rank</td> 
        <td>Name</td>";

  if (file_exists($geoip_path."GeoIP.dat"))
    echo "<td width=\"20\">Cntry</td>";

    $KillRatioTableWidth = 100;

 echo "
        <td align=\"center\">Kills</td>
        <td align=\"center\">Deaths</td>
        <td width=\"$KillRatioTableWidth\" align=\"center\">Ratio</td>
        <td align=\"center\">Skill</td>
        <td align=\"center\">Rounds</td>
        <td align=\"center\">Win streak</td>
        <td align=\"center\">Loss streak</td>
        </tr>
  ";
  
  if ($MaxKillRatio == 0)
  {
    // Determine the maximum ratio
    $query = "SELECT ${t['b3_clients']}.name, ${t['players']}.id, ${t['b3_clients']}.time_edit, ratio, ip
        FROM ${t['b3_clients']}, ${t['players']}
        WHERE (${t['b3_clients']}.id = ${t['players']}.client_id)
        AND ((${t['players']}.kills > $minkills)
          OR (${t['players']}.rounds > $minrounds))
        AND (${t['players']}.hide = 0)
        AND ($current_time - ${t['b3_clients']}.time_edit  < $maxdays*60*60*24)";
    if ($clan_name != "")
    {
      $query .= "AND (${t['b3_clients']}.name like '%%$clan_name%%')";
    }
    $query .= "ORDER BY ratio DESC, rounds ASC
        LIMIT 1";
    $result = $coddb->sql_query($query);
    $row = $coddb->sql_fetchrow($result);
    $MaxKillRatio = sprintf("%.2f",$row['ratio']);
  }

  $rank = $offset + 1;
  $rank_step = ($direction == "ASC" ? -1 : 1);
  
  $query = "SELECT ${t['b3_clients']}.name, ${t['b3_clients']}.time_edit, ${t['players']}.id, kills, deaths, ratio, skill, winstreak, losestreak, rounds, fixed_name, ip
        FROM ${t['b3_clients']}, ${t['players']}
        WHERE (${t['b3_clients']}.id = ${t['players']}.client_id)
        AND ((${t['players']}.kills > $minkills)
          OR (${t['players']}.rounds > $minrounds))
        AND (${t['players']}.hide = 0)
        AND ($current_time - ${t['b3_clients']}.time_edit  < $maxdays*60*60*24)";

  if ($clan_name != "")
    $query .= "AND (${t['b3_clients']}.name like '%%$clan_name%%')";

    $query .= "ORDER BY $sortby $direction";

  if ($toplist_max > 0)
    $query .= " LIMIT $offset, $toplist_max";
            
  $result = $coddb->sql_query($query);
  
  while ($row = $coddb->sql_fetchrow($result))
  {
    global $rankname;
    global $killsneeded;
    global $rankimage;   
    

    $kills =  get_rank_badge($row['kills']); 

    if ($separatorline == 1 && file_exists($geoip_path."GeoIP.dat"))
      echo "<tr><td colspan=\"11\" class=\"outertable\"><img src=\"/images/spacer.gif\" width=\"1\" height=\"1\" alt=\"\"></td></tr>";  // This draws a one pixel line between rows
    elseif ($separatorline == 1)
      echo "<tr><td colspan=\"10\" class=\"outertable\"><img src=\"/images/spacer.gif\" width=\"1\" height=\"1\" alt=\"\"></td></tr>";  // This draws a one pixel line between rows

    echo "<tr>";
    echo "<td align=\"center\"><strong>$rank</strong></td>";
      echo "<td><img src=\"./images/ranks/".$rankimage[$kills]."\" width=\"30\" height=\"30\" title=\"".$rankname[$kills]."\"></td>";

    echo "<td><a href=\"$link?func=player&playerid=${row['id']}\">", $row['fixed_name'] ? $row['fixed_name'] : $row['name'], "</a></td>";

    if (file_exists($geoip_path."GeoIP.dat"))
    {
      $geocountry = $geoip_path."GeoIP.dat";
      $ip = $row['ip'];
      $gi = geoip_open($geocountry,GEOIP_STANDARD);
      $countryid = strtolower (geoip_country_code_by_addr($gi, $ip));
      $country = geoip_country_name_by_addr($gi, $ip);
      if ( !is_null($countryid) and $countryid != "") 
        $flag = "<img src=\"images/flags/".$countryid.".gif\" title=\"".$country."\" alt=\"".$country."\">";
      else 
        $flag = "<img width=\"16\" height=\"11\" src=\"images/spacer.gif\" title=\"".$country."\" alt=\"".$country."\">"; 

      geoip_close($gi);
      echo "<td width=\"20\" align=\"center\">".$flag."</td>";
    }

    echo "<td align=\"center\">", $row['kills'] ? $row['kills'] : "", "</td>";
    echo "<td align=\"center\">${row['deaths']}</td>";
    $temp = sprintf("%.2f",$row['ratio']);

    if ( $temp >= 1 )
    {
      $KillRatioWidthMinus = 100;
      $KillRatioWidthMinusText = "Ratio " . $temp;
    }
    else
    {
      $KillRatioWidthMinus = intval($temp * 100);
      $KillRatioWidthMinusText = "Ratio " . $temp . " - " . $KillRatioWidthMinus . "% of 1:0 Ratio";
    }
    
    if ( $temp < 1 )
    {
      $KillRatioWidthPlus = "0";
      $KillRatioWidthPlusText = "";
    }
    else
    {
      $KillRatioWidthPlus = intval( ($temp / ($MaxKillRatio/100)) );
      if ( $KillRatioWidthPlus > 100 ) 
        $KillRatioWidthPlus = 100;
    
      $KillRatioWidthPlusText = "Ratio " . $temp . " - " . $KillRatioWidthPlus . "% of best Ratio (Which is " . $MaxKillRatio . ")";
    }

    if($ShowRatioGraph == 1)
    {
      echo "
      <td align=\"center\">
        <table width=\"$KillRatioTableWidth\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\" align=\"center\">
          <tr>
          <td bgcolor=\"#770000\" width=\"50%\"><!-- ratio with minus --> 
          <img align=\"middle\" src=\"./images/bars/bar-small/red_middle_9.png\" width=\"$KillRatioWidthMinus%\" height=\"9\" title=\"$KillRatioWidthMinusText\">";

          if ($temp >= $MaxKillRatio)
          {
            echo "</td><td bgcolor=\"#FFFF00\" width=\"50%\"><!-- ratio with plus --> 
            <img align=\"middle\" src=\"./images/bars/bar-small/yellow_middle_9.png\" width=\"$KillRatioWidthPlus%\" height=\"9\" title=\"$KillRatioWidthPlusText\">";
          }
          else
          {
            echo "</td><td bgcolor=\"#007700\" width=\"50%\"><!-- ratio with plus --> 
            <img align=\"middle\" src=\"./images/bars/bar-small/green_middle_9.png\" width=\"$KillRatioWidthPlus%\" height=\"9\" title=\"$KillRatioWidthPlusText\">";
          }
          echo "</td>         
          </tr>
        </table>
      </td>";
    }
    else
    {
      echo "<td align=\"center\">$temp</td>";
    }
    $temp = sprintf("%.1f",$row['skill']);
    echo "<td align=\"center\">$temp</td>";
    echo "<td align=\"center\">${row['rounds']}</td>";
    echo "<td align=\"center\">${row['winstreak']}</td>";
    echo "<td align=\"center\">",-$row['losestreak'],"</td>";
    echo "</tr>";
    $rank += $rank_step;
    }
    echo "</table>";
    echo "</td></tr><tr><td class=\"tiny\" align =\"right\">You need at least $minrounds rounds or $minkills kills to appear on this list!";
    echo "</td></tr></table>";    // Closing extra border-table
}


// Function that prints a table of the best weapons. The criterium (e.g. skill or kills) can be
// specified.
function topweapons($showplayercount = false, $sortby = "kills", $direction = "DESC", $offset = 0)
{

  $link = baselink();

  global $coddb;
  global $game;
  global $separatorline;
  global $t;  //table names
  global $w;  //weapon aliases
  
  global $weaplist_max;

  $sortfields = array("kills", "teamkills", "suicides");
  $sortby = strtolower($sortby);
  if (! in_array($sortby, $sortfields))
    $sortby = $sortfields[0];
  if ( $direction != "ASC")
    $direction = "DESC";

echo "
  <table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\" class=\"outertable\"><tr><td align=\"center\">Top $weaplist_max - Weapons with most $sortby</span></td></tr><tr><td>
  <table width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"0\" class=\"innertable\">
    <tr class=\"outertable\">
     <td align=\"center\" width=\"40\">Rank</td>
      <td>Name</td>
     <td align=\"center\" width=\"60\">View</td>
      <td align=\"center\">Total Kills</td>
<!--      <td align=\"center\">Total Teamkills</td> -->
<!--      <td align=\"center\">Total Suicides</td> -->
      ";

  if ($showplayercount == true)
    echo "<td>Nr of players</td>";
  echo "</tr>";
  
  $rank = $offset + 1;
  $rank_step = ($direction == "ASC" ? -1 : 1);
  
  $query = "SELECT id, name, kills, teamkills, suicides
      FROM ${t['weapons']}
      ORDER BY $sortby $direction";
  if ($weaplist_max > 0)
    $query .= " LIMIT $offset, $weaplist_max";
  //  $query .= " OFFSET $offset";
  
  $result = $coddb->sql_query($query);
  while ($row = $coddb->sql_fetchrow($result))
  {
    if ($separatorline == 1)
      echo "<tr><td colspan=\"11\" class=\"outertable\"><img src=\"/images/spacer.gif\" width=\"1\" height=\"1\" alt=\"\"></td></tr>";  // This draws a one pixel line between rows
    echo "<tr>";
    echo "<td align=\"center\"><strong>$rank</strong></td>";
    if (isset($w[$row['name']]))
      echo "<td><a href=\"$link?func=weapon&weaponid=${row['id']}\">".$w[ $row['name'] ]."</a></td>";
    else
      echo "<td><a href=\"$link?func=weapon&weaponid=${row['id']}\">${row['name']}</a></td>";
      
    //$weaponName = strtolower( $row['name']);
    
    echo "<td align=\"center\"><a href=\"$link?func=weapon&weaponid=${row['id']}\">";
    // catch cod1, coduo and cod2 in one imagefolder
    if ($game == "cod1" && !file_exists("./images/weapons/cod1/"))
      $gamename = "cod2";
    elseif ($game == "coduo" && !file_exists("./images/weapons/coduo/"))
      $gamename = "cod2";
    else
      $gamename = $game;
    get_pic("./images/weapons/$gamename/small/${row['name']}");
    echo "</a></td>";
      
    echo "<td align=\"center\">", $row['kills'] ? $row['kills'] : "", "</td>";
    
    if ($showplayercount == true)
      echo "<td>Unknown</td>";
    
    echo "</tr>";
    $rank += $rank_step;
  }
  echo "</table>";
  echo "</td></tr><tr><td class=\"tiny\" align =\"right\">Click on the weapon to see its stats!";
  echo "</td></tr></table>"; // Closing extra border-table
}


// Function that prints a table of the best maps. The criterium (e.g. skill or kills) can be
// specified.
function topmaps($showplayercount = false, $sortby = "kills", $direction = "DESC", $offset = 0)
{

  $link = baselink();
  global $coddb;
  global $game;
  global $separatorline;
  
  global $t;  //table names
  global $m;  //map aliases
  global $maplist_max;
  
  $sortfields = array("kills", "teamkills", "suicides", "rounds");
  $sortby = strtolower($sortby);
  if (! in_array($sortby, $sortfields))
    $sortby = $sortfields[0];
  if ( $direction != "ASC")
    $direction = "DESC";

echo "<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\" class=\"outertable\"><tr><td align=\"center\">Top $maplist_max - Maps with most $sortby</td></tr><tr><td>
  <table width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"0\" class=\"innertable\">
    <tr class=\"outertable\">
      <td align=\"center\" width=\"40\">Rank</td>
      <td align=\"center\">Map</td>
      <td align=\"center\" width=\"60\">View</td>
      <td align=\"center\">Total Kills</td>
      <td align=\"center\">Rounds</td>
    ";

  if ($showplayercount == true)
    echo "<td align=\"center\">Nr of players</td>";
  echo "</tr>";
  
  $rank = $offset + 1;
  $rank_step = ($direction == "ASC" ? -1 : 1);
  
  $query = "SELECT name, kills, teamkills, suicides, rounds, id 
      FROM ${t['maps']}
      ORDER BY $sortby $direction";
  if ($maplist_max > 0)
    $query .= " LIMIT $offset, $maplist_max";
  
  $result = $coddb->sql_query($query);
  while ($row = $coddb->sql_fetchrow($result))
  {
    if ($separatorline == 1)
      echo "<tr><td colspan=\"12\" class=\"outertable\"><img src=\"/images/spacer.gif\" width=\"1\" height=\"1\" alt=\"\"></td></tr>";  // This draws a one pixel line between rows
    echo "<tr>";
    echo "<td align=\"center\"><strong>$rank</strong></td>";

    if (isset($m[$row['name']]))
      echo "<td align=\"center\">"."  <a href=\"$link?func=map&mapid=${row['id']}\">".$m[ $row['name'] ]."</a></td>";
    else
      echo "<td align=\"center\"><a href=\"$link?func=map&mapid=${row['id']}\">${row['name']}</a></td>";

    //$mapName = strtolower($row['name']);

    echo "<td align=\"center\"><a href=\"$link?func=map&mapid=${row['id']}\">";
    // catch cod1, coduo and cod2 in one imagefolder
    if ($game == "cod1" && !file_exists("./images/maps/cod1/"))
      $gamename = "cod2";
    elseif ($game == "coduo" && !file_exists("./images/maps/coduo/"))
      $gamename = "cod2";
    else
      $gamename = $game;
    get_pic("./images/maps/$gamename/middle/${row['name']}");
    echo "</a></td>";

    echo "<td align=\"center\">", $row['kills'] ? $row['kills'] : "", "</td>";
    //echo "<td align=\"center\">", $row['teamkills'] ? $row['teamkills'] : "", "</td>";
    //echo "<td align=\"center\">", $row['suicides'] ? $row['suicides'] : "", "</td>";
    echo "<td align=\"center\">", $row['rounds'] ? $row['rounds'] : "", "</td>";
    
    if ($showplayercount == true)
      echo "<td>Unknown</td>";
    
    echo "</tr>";
    $rank += $rank_step;
  }
  echo "</table>";
  echo "</td></tr><tr><td class=\"tiny\" align =\"right\">Click on the map to see its stats!";
  echo "</td></tr></table>";                                                                // Closing extra border-table
}

//********************************************************************************
//
//  Functions for player specific data
//
//********************************************************************************

function player_badges($playerid, $dbID = false)
{
  global $coddb;
  global $separatorline;
  global $t; // table names from config
  global $aliashide_level;
  global $use_localtime;

  if($dbID == false)
  {
    $query = "SELECT ${t['b3_clients']}.name as clientname, ${t['b3_clients']}.time_add,
        ${t['b3_clients']}.time_edit, ${t['b3_clients']}.connections,
        ${t['b3_clients']}.group_bits,
        ${t['players']}.*
        FROM ${t['b3_clients']}, ${t['players']}
        WHERE ${t['players']}.id = $playerid
        AND (${t['b3_clients']}.id = ${t['players']}.client_id)
        AND hide = 0
        LIMIT 1";
  }
  else 
  {
    $query = "SELECT ${t['b3_clients']}.name as clientname, ${t['b3_clients']}.time_add,
            ${t['b3_clients']}.time_edit, ${t['b3_clients']}.connections,
            ${t['b3_clients']}.group_bits,
            ${t['players']}.*
            FROM ${t['b3_clients']}, ${t['players']}
            WHERE ${t['players']}.client_id = $playerid
            AND (${t['b3_clients']}.id = ${t['players']}.client_id)
            AND hide = 0
            LIMIT 1";
  }


  $result = $coddb->sql_query($query);
  $row = $coddb->sql_fetchrow($result);
  $playerid = $row['id'];  
    
  global $rankname;
  global $killsneeded;
  global $rankimage;   
  
  $kills =  get_rank_badge($row['kills']); 
  $next = 0;
  $percent = 100;
  $neexed = 0;
  $previmage = $kills -1;
  $nextimage = $kills + 1;
  
  if( $kills == count( $killsneeded)-1)
  {
    $next = $kills;        
    $percent = 100;
    $neexed =  "max";        
  }
  else if( $kills < count( $killsneeded)-1)
  {
    $next = $kills + 1;
    $neexed =  $killsneeded[$kills+1] - $row['kills'];
    $percent = intval((1-($neexed/($killsneeded[$kills+1]-$killsneeded[$kills])))*100);
  }
  else
  {
    $next = $kills;
    $percent = 100;
  }
  
  echo "<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\" class=\"outertable\"><tr><td>";
  echo "    <table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\" class=\"innertable\">";
  echo "        <tr class=\"outertable\">";
  echo "            <td colspan=\"3\" align=\"center\"><font class=\"fontNormal\" size=\"5\" face=\"Geneva, Arial, Helvetica, sans-serif\"><font color=\"#000000\">Rank</font></font></td>";
  echo "         </tr>";
  echo "         <tr bgcolor=\"#edf3f9\">";  
  echo "            <td colspan=\"3\">";  
  echo "              <table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\" class=\"innertable\">";   
  echo "                  <tr bgcolor=\"#edf3f9\">";                
  echo "                      <tr bgcolor=\"#dde3e9\">";  
  echo "                        <td align='center'>Previous</td><td align='center'>Current rank<br><strong>".$rankname[$kills]."</strong></td><td align='center'>Next</td>";
  echo "                      </tr>";  
  echo "             <td width=\"25%\" class=\"outertable\" colspan=\"1\" align=\"center\"><font class=\"fontNormal\" size=\"2\" face=\"Geneva, Arial, Helvetica, sans-serif\">";
  if($previmage != -1)
    echo "             <img src=\"./images/ranks/".$rankimage[$previmage]."\" width=\"60\" height=\"60\" border=\"1\">";

  else
    echo "None";
  
  echo "             </font></td> ";
  echo "             <td class=\"highlight\" colspan=\"1\" align=\"center\"><font class=\"fontNormal\" size=\"2\" face=\"Geneva, Arial, Helvetica, sans-serif\"><img src=\"./images/ranks/".$rankimage[$kills]."\" width=\"112\" height=\"112\" border=\"1\"></font></td> ";

  echo "             <td  width=\"25%\" class=\"outertable\"  colspan=\"1\" align=\"center\"><font class=\"fontNormal\" size=\"2\" face=\"Geneva, Arial, Helvetica, sans-serif\">";
  if($nextimage < count( $killsneeded))   
    echo "             <img src=\"./images/ranks/".$rankimage[$nextimage]."\" width=\"60\" height=\"60\" border=\"1\">";
  else
    echo "None (max)";

  echo "             </font></td> "; 
  echo "                  </tr>";
  echo "              </table></td>";     
  echo "         </tr>";   
  echo "         <tr bgcolor=\"#e8e8e8\"> "; 
  echo "          <td colspan=\"2\" width=\"600\">  "; 
  echo "          <div style=\"padding: 0px; background-image: url('images/bars/bar-small/red_middle_9.png'); background-repeat: repeat-x;\" height=\"9\"><img src=\"images/bars/bar-small/green_middle_9.png\" alt=\"&nbsp;Progress till next rank\" width=\"".$percent."%\" height=\"9\"></div></td> "; 
  echo "          <td align=\"center\" width=\"200\"><font color=\"#000000\" size=\"2\">Kills needed: <b>".$neexed." (".$percent."%)</b></font></td></tr>  "; 
  echo "     </table>";
  echo "</table>";
}

function get_rank_badge($kills)
{
  global $killsneeded; 
  $result = 0;
  for($counter = 0;$counter < count( $killsneeded);$counter+=1)
  {
    if($killsneeded[$counter] < $kills)
      $result = $counter;
    else
      return $result;  
  }   
  return $result;
}


// This function gives a short overview of the players stats, like skill, kills, rounds, etc
function player_short($playerid, $dbID = false)
{
  global $coddb;
  global $separatorline;
  global $t; // table names from config
  global $aliashide_level;
  global $use_localtime;
  global $geoip_path;
  global $groupbits;
  global $limitplayerstats;
  global $sig;

  if($dbID == false)
  {
      $query = "SELECT ${t['b3_clients']}.name as clientname, ${t['b3_clients']}.time_add, ${t['b3_clients']}.ip,
          ${t['b3_clients']}.time_edit, ${t['b3_clients']}.connections,
          ${t['b3_clients']}.group_bits,
          ${t['players']}.*
          FROM ${t['b3_clients']}, ${t['players']}
          WHERE ${t['players']}.id = $playerid
          AND (${t['b3_clients']}.id = ${t['players']}.client_id)
          AND hide = 0
          LIMIT 1";
  }
  else 
  {
      $query = "SELECT ${t['b3_clients']}.name as clientname, ${t['b3_clients']}.time_add, ${t['b3_clients']}.ip,
              ${t['b3_clients']}.time_edit, ${t['b3_clients']}.connections,
              ${t['b3_clients']}.group_bits,
              ${t['players']}.*
              FROM ${t['b3_clients']}, ${t['players']}
              WHERE ${t['players']}.client_id = $playerid
              AND (${t['b3_clients']}.id = ${t['players']}.client_id)
              AND hide = 0
              LIMIT 1";
  }


  $result = $coddb->sql_query($query);
  $row = $coddb->sql_fetchrow($result);
  if ($row == false)
    return;

  $playerid = $row['id'];
  $link = baselink();
  
  if (file_exists($geoip_path."GeoIP.dat"))
  {
    $geocountry = $geoip_path."GeoIP.dat";
    $ip = $row['ip'];
    $gi = geoip_open($geocountry,GEOIP_STANDARD);
    $countryid = strtolower (geoip_country_code_by_addr($gi, $ip));
    $country = geoip_country_name_by_addr($gi, $ip);
    if ( !is_null($countryid) and $countryid != "") 
      $flag = "<img src=\"images/flags/".$countryid.".gif\" title=\"".$country."\" alt=\"".$country."\">";
    else 
      $flag = "<img width=\"16\" height=\"11\" src=\"images/spacer.gif\" title=\"".$country."\" alt=\"".$country."\">"; 
    geoip_close($gi);
  }


  echo "<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\" class=\"outertable\">";
  echo "  <tr>";
  echo "    <td width=\"210\" valign=\"top\" class=\"innertable\"><table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"1\" class=\"innertable\">";
  echo "       <tr>";
  echo "        <td>PlayerID</td>";
  echo "        <td>$playerid</td>";
  echo "      </tr>";
  echo "      <tr>";
  echo "        <td>Kills</td>";
  echo "        <td>${row['kills']}</td>";
  echo "      </tr>";
  echo "      <tr>";
  echo "        <td>Deaths</td>";
  echo "        <td>${row['deaths']}</td>";
  echo "      </tr>";
  echo "      <tr>";
  echo "        <td>Suicides</td>";
  echo "        <td>${row['suicides']}</td>";
  echo "      </tr>";
  echo "      <tr>";
  $temp = sprintf("%.2f",$row['ratio']);
  echo "        <td>Ratio</td>";
  echo "        <td>$temp</td>";
  echo "      </tr>";
  echo "      <tr>";
  $temp = sprintf("%.1f",$row['skill']);
  echo "        <td>Skill</td>";
  echo "        <td>$temp</td>";
  echo "      </tr>";
  echo "      <tr>";
  echo "        <td>Rounds</td>";
  echo "        <td>${row['rounds']}</td>";
  echo "      </tr>";
  echo "      <tr>";
  echo "        <td>Longest winning streak</td>";
  echo "        <td>${row['winstreak']}</td>";
  echo "      </tr>";
  echo "      <tr>";
  echo "        <td>Longest losing streak</td>";
  echo "        <td>".-1*$row['losestreak']."</td>";
  echo "      </tr>";
  echo "      <tr>";
  echo "        <td>Team kills</td>";
  echo "        <td>${row['teamkills']}</td>";
  echo "      </tr>";
  echo "      <tr>";
  echo "        <td>Team deaths</td>";
  echo "        <td>${row['teamdeaths']}</td>";
  echo "      </tr>";
  echo "    </table></td>";

// This is the right part of the table with extra playerinfo
  $playername = $row['fixed_name'] ? $row['fixed_name'] : $row['clientname'];
  $groupbits = $row['group_bits'];

  echo "<td valign=\"top\">";
  echo "Personal statistics of <span class=\"highlight\">", $playername, "</span>";
  if ($groupbits > 0 || $limitplayerstats == 0)
    echo "&nbsp;&nbsp;&nbsp;<a href=\"", $link, "?func=saveme&playerid=", $playerid, "\"><img src=\"images/ico/user_add.png\" border=\"0\" align=\"absbottom\" title=\"This is me! Remember me in 'MyStats'!\"></a>";
  echo "<br/><br/><span class=\"highlight\">".$playername."</span> was first registered by B3 on <span class=\"highlight\">";
  if ($use_localtime == 1)
    echo date("j F Y, G:i T", $row['time_add']+date("Z")). ",</span><br/>";
  else
    echo date("j F Y, G:i", $row['time_add']). " GMT,</span><br/>";
  echo "connected <span class=\"highlight\">${row['connections']}</span> times,<br/>";
  echo "was last seen playing on <span class=\"highlight\">"; 
  if ($use_localtime == 1)
    echo date("j F Y, G:i T", $row['time_edit']+date("Z")). ",</span><br/>";
  else
    echo date("j F Y, G:i", $row['time_edit']). " GMT,</span><br/>";

  // Getting the highest group a player is in. 
  if ($groupbits == 0)
  {
  echo "and has not registered with B3 yet!<br/>Register as a User: While ingame type !register</span> in chat.";
  if ($limitplayerstats == 1)
    echo "<br/><span class=\"attention\">Registering will enable more player specific statistics";
    if ($sig == 1) echo " and the 'Signature Generator'";
    echo " on this page!</span>";
  echo "<br/><br/>";
  }
  else
  {
    for ($group=0; $groupbits >= (1<<$group); $group++);
        $group = 1 << ($group-1);

    $query2 = "SELECT name FROM ${t['b3_groups']} WHERE id=$group";
    $result2 = $coddb->sql_query($query2);
    if ($coddb->sql_numrows($result2) > 0)
    {
        $row2 = $coddb->sql_fetchrow($result2);
        echo "and is known as <span class=\"highlight\">${row2['name']}.</span><br/><br/>";
    }
    else
    {
        echo "and is member of an unknown group.<br/><br/>";
    }
  }
  if (file_exists($geoip_path."GeoIP.dat"))
  {
    echo "<span class=\"highlight\">$playername</span> is connecting from: ";
    echo $flag." ";
    echo "<span class=\"highlight\">$country.</span><br/><br/>";
    
  }

// Getting the aliases for the player. Could be more than one!

$query3 = "SELECT ${t['b3_aliases']}.*,
                  ${t['players']}.id, ${t['players']}.client_id, ${t['players']}.hide
          FROM  ${t['players']}, ${t['b3_aliases']}
          WHERE ${t['players']}.id = $playerid
            AND ${t['b3_aliases']}.client_id = ${t['players']}.client_id
            AND hide = 0";



$result3 = $coddb->sql_query($query3);

  if ($row['group_bits'] < $aliashide_level)
  {
    if ($row3 = $coddb->sql_fetchrow($result3))
    {
      echo "Known aliases for this player are:<br/>";
      echo "<span class=\"highlight\">${row3['alias']}</span>";
      while ($row3 = $coddb->sql_fetchrow($result3))
        echo ", <span class=\"highlight\">${row3['alias']}</span>";
    }
  }

  if ($groupbits > 0 || $limitplayerstats == 0)
    showsig($playerid);

// Closing the tables
  echo "</td></tr></table>";
}

// This function prints a table showing a players achievements with the various weapons,
// both in hitting and being hit
function player_weapons_s($playerid, $dbID = false)
{
  $link = baselink();
  global $coddb;
  global $separatorline;
     
  global $t; // table names from config
  global $w; // weapon names from config
  $Output = "";
  //<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\" class=\"outertable\"><tr><td align=\"center\">Weapon achievements</td></tr><tr><td>
  $Output = "
  <table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\" class=\"outertable\"><tr><td>
    <table width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"0\" class=\"innertable\">
        <tr class=\"outertable\">
            <td width=250 colspan=\"1\" >Your favorite weapons</td>
            <td align=\"center\">Your Kills</td>
            <td width=320 align=\"center\">Your K/D Ratio</td>
            <td colspan=\"2\" align=\"center\">Your Deaths</td>
    ";
    
    if($dbID == false)
    {
      $query = "SELECT id, kills, deaths, suicides, teamkills, teamdeaths 
                FROM ${t['players']}
                WHERE id = $playerid AND hide = 0
                LIMIT 1";
    }
    else 
    {
      $query = "SELECT id, kills, deaths, suicides, teamkills, teamdeaths 
                FROM ${t['players']}
                WHERE ${t['players']}.client_id = $playerid
                AND hide = 0
                LIMIT 1";
    }
  $result = $coddb->sql_query($query);
  $row = $coddb->sql_fetchrow($result);
  if ($row == false) 
      return;  // no result given: does not exist or is hidden. Anyway, return whence thou camest!
     
  $playerid = $row['id'];
  $kills = $row['kills'];
  $deaths = $row['deaths'];
  $suicides = $row['suicides'];
  $teamkills = $row['teamkills'];
  $teamdeaths = $row['teamdeaths'];
  
  $query = "SELECT ${t['weapons']}.name, ${t['weapons']}.id, ${t['weaponusage']}.kills, 
                ${t['weaponusage']}.deaths, ${t['weaponusage']}.suicides, 
                ${t['weaponusage']}.teamkills, ${t['weaponusage']}.teamdeaths
            FROM ${t['weapons']}, ${t['weaponusage']}
            WHERE ${t['weaponusage']}.player_id = $playerid
                AND ${t['weapons']}.id = ${t['weaponusage']}.weapon_id
            ORDER BY ${t['weaponusage']}.kills DESC";


  $result = $coddb->sql_query($query);
  
  while ($row = $coddb->sql_fetchrow($result))
  {      
    if ($separatorline == 1)
      $Output .= "<tr><td colspan=\"11\" class=\"outertable\"><img src=\"/images/spacer.gif\" width=\"1\" height=\"1\" alt=\"\"></td></tr>
      ";  // This draws a one pixel line between rows

    $Output .= "<tr>
    ";
           
    if (isset($w[$row['name']]))
      $Output .= "<td><a href=\"$link?func=weapon&weaponid=${row['id']}\">".$w[ $row['name'] ]."</a></td>
      ";
    else
      $Output .= "<td><a href=\"$link?func=weapon&weaponid=${row['id']}\">${row['name']}</a></td>
      ";
      // $outtmp ="  <td align=\"center\">", $row['kills'] ? $row['kills'] : "", "</td>";
      $Output .= "  <td align=\"center\">";
  
      // echo "  <td align=\"center\">", $row['kills'] ? $row['kills'] : "", "</td>";     
 
    if($row['kills'] ==  "")
    {
     $Output .= "</td>
     ";       
    }
    else
    {
     $Output .= $row['kills']."</td> 
     ";      
    }
    
    $ratiola = 0;
    
    if ( ($kills > 0) && ($row['kills'] > 0) )
    {
      $ratiola = $temp = sprintf("%.2f", $row['kills']/($kills/100));
      if(intval($ratiola) >= 99)
        $temp = "97.50";
    }
    else
      $Output .= "  </td>";                                                                 
     
    $Output .= "<td align=\"center\">
      <table width=\"100%\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\" align=\"center\">
        <tr>
        <td  width=\"100%\">
        ";
        if($ratiola > 0.00 )
            $Output .= "<img align=\"middle\" src=\"./images/bars/bar-small/green_left_9.png\" width=\"4\" height=\"9\" title=\"$ratiola %\"><img align=\"middle\" src=\"./images/bars/bar-small/green_middle_9.png\" width=".$temp."%\" height=\"9\" alt=".$ratiola." title=\"$ratiola %\"><img align=\"middle\" src=\"./images/bars/bar-small/green_right_9.png\" width=\"4\" height=\"9\"  title=\"$ratiola %\" ></td>
            ";
              
    $Output .= "    </td>
      </tr>
    </table>
        </td>
    </td>
    ";      

    $Output .= "  <td align=\"center\">";
     if($row['deaths'] ==  "")
     {
       $Output .= "</td>
       ";       
     }
     else
     {
       $Output .= $row['deaths']."</td> 
       ";      
     }
    
    if ( ($deaths > 0) && ($row['deaths'] > 0) )
    {
      $temp = sprintf("%.2f", 100*$row['deaths']/$deaths);
      $Output .= "  <td align=\"center\" class=\"tiny\">($temp%)</td>
      ";   
    }
    else
    {
      $Output .= "  <td></td>
      ";
    }                                      
    $Output .= "</tr>
    ";   
  }                              
  $Output .= "</table>
  ";
  $Output .= "</td></tr><tr><td class=\"tiny\" align =\"right\">Extra skillpoints are awarded for bashing, killing with pistols and other difficult weapons!
  ";
  $Output .= "</td></tr></table>
  ";     // Closing extra border-table
  return $Output;
}

// This function prints a table showing a players achievements with the various weapons,
// both in hitting and being hit
function player_weapons($playerid, $dbID = false)
{
  $link = baselink();
  global $coddb;
  global $separatorline;
     
  global $t; // table names from config
  global $w; // weapon names from config
  
echo "<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\" class=\"outertable\"><tr><td align=\"center\">Weapon achievements</td></tr><tr><td>
      <table width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"0\" class=\"innertable\">
      <tr class=\"outertable\">
        <td width=250 colspan=\"1\" >Weapon</td>
        <td align=\"center\">Kills</td>
        <td width=320 align=\"center\">Ratio</td>
        <td colspan=\"2\" align=\"center\">Deaths</td>
      <!--    <td colspan=\"2\" align=\"center\">Suicides</td> -->
      <!--    <td colspan=\"2\" align=\"center\">Team Kills</td> -->
      <!--    <td colspan=\"2\" align=\"center\">Team Deaths</td></tr> -->
     ";
  
  if($dbID == false)
  {
    $query = "SELECT id, kills, deaths, suicides, teamkills, teamdeaths 
              FROM ${t['players']}
              WHERE id = $playerid AND hide = 0
              LIMIT 1";
  }
  else 
  {
    $query = "SELECT id, kills, deaths, suicides, teamkills, teamdeaths 
              FROM ${t['players']}
              WHERE ${t['players']}.client_id = $playerid
              AND hide = 0
              LIMIT 1";
  }
  $result = $coddb->sql_query($query);
  $row = $coddb->sql_fetchrow($result);
  if ($row == false) 
    return;  // no result given: does not exist or is hidden. Anyway, return whence thou camest!
  
  $playerid = $row['id'];
  $kills = $row['kills'];
  $deaths = $row['deaths'];
  $suicides = $row['suicides'];
  $teamkills = $row['teamkills'];
  $teamdeaths = $row['teamdeaths'];
  
  $query = "SELECT ${t['weapons']}.name, ${t['weapons']}.id, ${t['weaponusage']}.kills, 
                ${t['weaponusage']}.deaths, ${t['weaponusage']}.suicides, 
                ${t['weaponusage']}.teamkills, ${t['weaponusage']}.teamdeaths
            FROM ${t['weapons']}, ${t['weaponusage']}
            WHERE ${t['weaponusage']}.player_id = $playerid
                AND ${t['weapons']}.id = ${t['weaponusage']}.weapon_id
            ORDER BY ${t['weaponusage']}.kills DESC";


  $result = $coddb->sql_query($query);
  
  while ($row = $coddb->sql_fetchrow($result))
  {
    if ($separatorline == 1)
      echo "<tr><td colspan=\"11\" class=\"outertable\"><img src=\"/images/spacer.gif\" width=\"1\" height=\"1\" alt=\"\"></td></tr>";  // This draws a one pixel line between rows
    echo "<tr>";
    
    if (isset($w[$row['name']]))
      echo "<td><a href=\"$link?func=weapon&weaponid=${row['id']}\">".$w[ $row['name'] ]."</a></td>";
    else
      echo "<td><a href=\"$link?func=weapon&weaponid=${row['id']}\">${row['name']}</a></td>";
      
    echo "  <td align=\"center\">", $row['kills'] ? $row['kills'] : "", "</td>";
    
    $ratiola = 0;
    
    if ( ($kills > 0) && ($row['kills'] > 0) )
      $ratiola = $temp = sprintf("%.2f", $row['kills']/($kills/100));
    else
      echo "  </td>";
  
    echo "<td align=\"center\">
      <table width=\"100%\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\" align=\"center\">
        <tr>
        <td  width=\"100%\">";
    if($ratiola > 0.00 )
      echo "<img align=\"middle\" src=\"./images/bars/bar-small/green_left_9.png\" width=\"\" height=\"9\" title=\"$ratiola %\"><img align=\"middle\" src=\"./images/bars/bar-small/green_middle_9.png\" width=".$ratiola."%\" height=\"9\" alt=".$ratiola." title=\"$ratiola %\"><img align=\"middle\" src=\"./images/bars/bar-small/green_right_9.png\" width=\"\" height=\"9\"  title=\"$ratiola %\" ></td>";
        
    echo "  </td>
            </tr>
          </table>
          </td>
        </td>";      
    echo "  <td align=\"center\">", $row['deaths'] ? $row['deaths'] : "", "</td>";
    if ( ($deaths > 0) && ($row['deaths'] > 0) )
    {
      $temp = sprintf("%.2f", 100*$row['deaths']/$deaths);
      echo "  <td align=\"center\" class=\"tiny\">($temp%)</td>";   
    }
    else
      echo "  <td></td>";

    echo "</tr>";
  }
  echo "</table>";
  echo "</td></tr><tr><td class=\"tiny\" align =\"right\">Extra skillpoints are awarded for bashing, killing with pistols and other difficult weapons!";
  echo "</td></tr></table>";     // Closing extra border-table
}
  
function player_bodyparts_s($playerid, $dbID = false)
{
  $Output = "";              
  $link = baselink();
    
  global $coddb;
  global $separatorline;
  global $t; // table names from config
  global $b; // bodypart names from config
  global $game;
  global $groupbits;
  //<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\" class=\"outertable\"><tr><td align=\"center\">Hitzones</td></tr><tr><td>   
  
  $Output = 
"  <table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\" class=\"outertable\"><tr valign=\"top\"><td>  
    <table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\" class=\"outertable\"><tr><td>
        <table width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"0\" class=\"innertable\">
            <tr class=\"outertable\">
                <td width=\"250\">Bodyparts</td>
                <td width=\"140\"colspan=\"2\" align=\"center\">Your Kills</td>
                <td width=\"140\"colspan=\"2\" align=\"center\">Your Deaths</td>
    ";
    if($dbID == false)
    {
        $query = "SELECT id, kills, deaths, suicides, teamkills, teamdeaths
                FROM ${t['players']}
                WHERE id = $playerid AND hide = 0
                LIMIT 1";
    }
    else 
    {
        $query = "SELECT id, kills, deaths, suicides, teamkills, teamdeaths
                FROM ${t['players']}
                WHERE client_id = $playerid AND hide = 0
                LIMIT 1";
    }
    $result = $coddb->sql_query($query);
    $row = $coddb->sql_fetchrow($result);

    $playerid =  $row['id'];
    $kills = $row['kills'];
    $deaths = $row['deaths'];
    $suicides = $row['suicides'];
    $teamkills = $row['teamkills'];
    $teamdeaths = $row['teamdeaths'];
  
    $query = "SELECT ${t['bodyparts']}.name, ${t['bodyparts']}.id, ${t['playerbody']}.kills, 
            ${t['playerbody']}.deaths, ${t['playerbody']}.suicides, 
            ${t['playerbody']}.teamkills, ${t['playerbody']}.teamdeaths
            FROM ${t['bodyparts']}, ${t['playerbody']}
            WHERE ${t['playerbody']}.player_id = $playerid
            AND ${t['bodyparts']}.id = ${t['playerbody']}.bodypart_id
            ORDER BY ${t['playerbody']}.kills DESC";
  

    $result = $coddb->sql_query($query);

    $mybodypats = array();

    while ($row = $coddb->sql_fetchrow($result))
    {
      if ($separatorline == 1)
      {
        $Output .=  "<tr><td colspan=\"11\" class=\"outertable\"><img src=\"/images/spacer.gif\" width=\"1\" height=\"1\" alt=\"\"></td></tr>
        ";  // This draws a one pixel line between rows
      }
      $Output .= "<tr>";

      $bset = false;
      if (isset($b[$row['name']]))
      {
        $Output .= "  <td>".$b[ $row['name'] ]."</td>
        ";
        $bset = true;
      }
      else
        $Output .=  "  <td>${row['name']}</td>";                
      $Output .=  "  <td align=\"center\">";
      if($row['kills'] ==  "")
      {
        $Output .= "</td>
        ";       
      }
      else
      {
        $Output .= $row['kills']."</td>
        ";
      }
  
      if ( ($kills > 0) && ($row['kills'] > 0) )
      {
        $temp = sprintf("%.2f", 100*$row['kills']/$kills);
        $Output .= "  <td align=\"center\" class=\"tiny\">($temp%)</td>
        ";   
        $mybodypats[ $row['name'] ] = sprintf("%.0f", intval(round(($row['kills']/$kills), 1)*10) * 10);      
      }
      else
        $Output .= "  <td></td>";

      $Output .=    "  <td align=\"center\">";
      if($row['deaths'] ==  "")
      {
        $Output .= "</td>
        ";       
      }
      else
      {
        $Output .= $row['deaths']."</td>
        ";   
      }
      if ( ($deaths > 0) && ($row['deaths'] > 0) )
      {
        $temp = sprintf("%.2f", 100*$row['deaths']/$deaths);
        $Output .= "  <td align=\"center\" class=\"tiny\">($temp%)</td>
        ";   
      }
      else
      {
        $Output .= "  <td></td>
        ";
      }

      $Output .= "</tr>";
    }
    $Output .= "</table>
    ";
    $Output .= "</td>
    </tr>
    <tr>    
        <td class=\"tiny\" align =\"right\">Watch your cover and aim for deadly hitzones on your opponents!
    ";
    $Output .= "    </td>
            </tr>
        </table> 
    ";    
      //<td align=\"center\" width=\"1\" width=\"10\">&nbsp;</td>
      
  if($game == "urt") {
    $hz_head = $mybodypats['0']+$mybodypats['1']; // Head + helmet
    $hz_neck = $mybodypats['none']; // Neck doesn't exist
    $hz_torso_upper = $mybodypats['2']+$mybodypats['3']; // Torso + kevlar
    $hz_torso_lower = $mybodypats['2']+$mybodypats['3']; // Torso + kevlar
    $hz_left_arm_upper = $mybodypats['4']; // Arms
    $hz_left_arm_lower = $mybodypats['4']; // Arms
    $hz_left_hand = $mybodypats['4']; // Arms
    $hz_right_arm_upper = $mybodypats['4']; // Arms
    $hz_right_arm_lower = $mybodypats['4']; // Arms
    $hz_right_hand = $mybodypats['4']; // Arms
    $hz_left_leg_upper = $mybodypats['5']; // Legs
    $hz_left_leg_lower = $mybodypats['5']; // Legs
    $hz_left_foot = $mybodypats['5']; // Legs
    $hz_right_leg_upper = $mybodypats['5']; // Legs
    $hz_right_leg_lower = $mybodypats['5']; // Legs
    $hz_right_foot = $mybodypats['5']; // Legs
    $hz_none = $mybodypats['none'];
  }
  else {
    $hz_head = $mybodypats['head'];
    $hz_neck = $mybodypats['neck'];
    $hz_torso_upper = $mybodypats['torso_upper'];
    $hz_torso_lower = $mybodypats['torso_lower'];
    $hz_left_arm_upper = $mybodypats['left_arm_upper'];
    $hz_left_arm_lower = $mybodypats['left_arm_lower'];
    $hz_left_hand = $mybodypats['left_hand'];
    $hz_right_arm_upper = $mybodypats['right_arm_upper'];
    $hz_right_arm_lower = $mybodypats['right_arm_lower'];
    $hz_right_hand = $mybodypats['right_hand'];
    $hz_left_leg_upper = $mybodypats['left_leg_upper'];
    $hz_left_leg_lower = $mybodypats['left_leg_lower'];
    $hz_left_foot = $mybodypats['left_foot'];
    $hz_right_leg_upper = $mybodypats['right_leg_upper'];
    $hz_right_leg_lower = $mybodypats['right_leg_lower'];
    $hz_right_foot = $mybodypats['right_foot'];
    $hz_none = $mybodypats['none'];
  }

    $zero = "0";
    $Output .= "</td>
    <td> &nbsp; </td> 
    <td> 
      <table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\" class=\"outertable\"><tr><td>
        <table width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"0\" class=\"innertable\">
            <tr class=\"outertable\">
                <td width=\"250\">Accuracy</td> 
                <tr>
                    <td>   
                        <table id=\"Table_01\" width=\"370\" height=\"584\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">
                            <tr>
                                <td colspan=\"14\">
                                    <img src=\"./images/model/common/0_01.png\" width=\"370\" height=\"31\" alt=\"\"></td>
                                <td height=\"31\" nowrap></td>
                            </tr>
                            <tr>
                                <td colspan=\"6\">
                                    <img src=\"./images/model/common/0_02.png\" width=\"140\" height=\"94\" alt=\"\"></td>
                                <td colspan=\"2\">
                                    <img src=\"./images/model/".(getPercent($hz_head, $kills))."/head.png\" width=\"90\" height=\"94\" alt=\"\"></td>
                                <td colspan=\"6\">
                                    <img src=\"./images/model/common/0_04.png\" width=\"140\" height=\"94\" alt=\"\"></td>
                                <td height=\"94\" nowrap></td>
                            </tr>
                            <tr>
                                <td colspan=\"4\">
                                    <img src=\"./images/model/common/0_05.png\" width=\"102\" height=\"28\" alt=\"\"></td>
                                <td colspan=\"6\">
                                    <img src=\"./images/model/".(getPercent($hz_neck, $kills))."/neck.png\" width=\"166\" height=\"28\" alt=\"\"></td>
                                <td colspan=\"4\">
                                    <img src=\"./images/model/common/0_07.png\" width=\"102\" height=\"28\" alt=\"\"></td>
                                <td height=\"28\" nowrap></td>
                            </tr>
                            <tr>
                                <td colspan=\"2\">
                                    <img src=\"./images/model/common/0_08.png\" width=\"57\" height=\"62\" alt=\"\"></td>
                                <td colspan=\"3\">
                                    <img src=\"./images/model/".(getPercent($hz_left_arm_upper, $kills))."/left_arm_upper.png\" width=\"68\" height=\"62\" alt=\"\"></td>
                                <td colspan=\"4\" rowspan=\"2\">
                                    <img src=\"./images/model/".(getPercent($hz_torso_upper, $kills))."/chest.png\" width=\"120\" height=\"97\" alt=\"\"></td>
                                <td colspan=\"3\">
                                    <img src=\"./images/model/".(getPercent($hz_right_arm_upper, $kills))."/right_arm_upper.png\" width=\"61\" height=\"62\" alt=\"\"></td>
                                <td colspan=\"2\">
                                    <img src=\"./images/model/common/0_12.png\" width=\"64\" height=\"62\" alt=\"\"></td>
                                <td height=\"62\" nowrap></td>
                            </tr>
                            <tr>
                                <td rowspan=\"2\">
                                    <img src=\"./images/model/common/0_13.png\" width=\"27\" height=\"47\" alt=\"\"></td>
                                <td colspan=\"3\" rowspan=\"2\">
                                    <img src=\"./images/model/".(getPercent($hz_left_arm_lower, $kills))."/left_arm_lower.png\" width=\"75\" height=\"47\" alt=\"\"></td>
                                <td>
                                    <img src=\"./images/model/common/0_15.png\" width=\"23\" height=\"35\" alt=\"\"></td>
                                <td>
                                    <img src=\"./images/model/common/0_16.png\" width=\"23\" height=\"35\" alt=\"\"></td>
                                <td colspan=\"3\" rowspan=\"2\">
                                    <img src=\"./images/model/".(getPercent($hz_right_arm_lower, $kills))."/right_arm_lower.png\" width=\"71\" height=\"47\" alt=\"\"></td>
                                <td rowspan=\"2\">
                                    <img src=\"./images/model/common/0_18.png\" width=\"31\" height=\"47\" alt=\"\"></td>
                                <td height=\"35\" nowrap></td>
                            </tr>
                            <tr>
                                <td colspan=\"6\" rowspan=\"2\">
                                    <img src=\"./images/model/".(getPercent($hz_torso_lower, $kills))."/torso_lower.png\" width=\"166\" height=\"60\" alt=\"\"></td>
                                <td height=\"12\" nowrap></td>
                            </tr>
                            <tr>
                                <td colspan=\"3\" rowspan=\"2\">
                                    <img src=\"./images/model/".(getPercent($hz_left_hand, $kills))."/left_hand.png\" width=\"69\" height=\"59\" alt=\"\"></td>
                                <td rowspan=\"6\">
                                    <img src=\"./images/model/common/0_21.png\" width=\"33\" height=\"322\" alt=\"\"></td>
                                <td rowspan=\"6\">
                                    <img src=\"./images/model/common/0_22.png\" width=\"27\" height=\"322\" alt=\"\"></td>
                                <td colspan=\"3\" rowspan=\"2\">
                                    <img src=\"./images/model/".(getPercent($hz_right_hand, $kills))."/right_hand.png\" width=\"75\" height=\"59\" alt=\"\"></td>
                                <td height=\"48\" nowrap></td>
                            </tr>
                            <tr>
                                <td colspan=\"3\" rowspan=\"2\">
                                    <img src=\"./images/model/".(getPercent($hz_left_leg_upper, $kills))."/left_leg_upper.png\" width=\"83\" height=\"84\" alt=\"\"></td>
                                <td colspan=\"3\" rowspan=\"2\">
                                    <img src=\"./images/model/".(getPercent($hz_right_leg_upper, $kills))."/right_leg_upper.png\" width=\"83\" height=\"84\" alt=\"\"></td>
                                <td height=\"11\" nowrap></td>
                            </tr>
                            <tr>
                                <td colspan=\"3\" rowspan=\"4\">
                                    <img src=\"./images/model/common/0_26.png\" width=\"69\" height=\"263\" alt=\"\"></td>
                                <td colspan=\"3\" rowspan=\"4\">
                                    <img src=\"./images/model/common/0_27.png\" width=\"75\" height=\"263\" alt=\"\"></td>
                                <td height=\"73\" nowrap></td>
                            </tr>
                            <tr>
                                <td rowspan=\"3\">
                                    <img src=\"./images/model/common/0_28.png\" width=\"23\" height=\"190\" alt=\"\"></td>
                                <td colspan=\"2\">
                                    <img src=\"./images/model/".(getPercent($hz_left_leg_lower, $kills))."/left_leg_lower.png\" width=\"60\" height=\"98\" alt=\"\"></td>
                                <td colspan=\"2\">
                                    <img src=\"./images/model/".(getPercent($hz_right_leg_lower, $kills))."/right_leg_lower.png\" width=\"60\" height=\"98\" alt=\"\"></td>
                                <td rowspan=\"3\">
                                    <img src=\"./images/model/common/0_31.png\" width=\"23\" height=\"190\" alt=\"\"></td>
                                <td height=\"98\" nowrap></td>
                            </tr>
                            <tr>
                                <td colspan=\"2\">
                                    <img src=\"./images/model/".(getPercent($hz_left_foot, $kills))."/left_foot.png\" width=\"60\" height=\"63\" alt=\"\"></td>
                                <td colspan=\"2\">
                                    <img src=\"./images/model/".(getPercent($hz_right_foot, $kills))."/right_foot.png\" width=\"60\" height=\"63\" alt=\"\"></td>
                                <td height=\"63\" nowrap></td>
                            </tr>
                            <tr>
                                <td colspan=\"4\">
                                    <img src=\"./images/model/common/0_34.png\" width=\"120\" height=\"29\" alt=\"\"></td>
                                <td height=\"29\" nowrap></td>
                            </tr>
                            <tr>
                                <td width=\"27\" nowrap></td>
                                <td width=\"30\" nowrap></td>
                                <td width=\"12\" nowrap></td>
                                <td width=\"33\" nowrap></td>
                                <td width=\"23\" nowrap></td>
                                <td width=\"15\" nowrap></td>
                                <td width=\"45\" nowrap></td>
                                <td width=\"45\" nowrap></td>
                                <td width=\"15\" nowrap></td>
                                <td width=\"23\" nowrap></td>
                                <td width=\"27\" nowrap></td>
                                <td width=\"11\" nowrap></td>
                                <td width=\"33\" nowrap></td>
                                <td width=\"31\" nowrap></td>
                                <td></td>
                            </tr>
                        </table>
                      </td> 
               </tr>
               </td>
            </table>
            </td>
            </tr>
            </table>
         </td>
        </tr>
        </table> 
    ";
    
    
    return $Output;                                                            // Closing extra border-table
}  

function getPercent($killpercentage, $totalkills)
{
  if($totalkills == "")
    return "0";
  elseif($killpercentage == "")
    return "0";
  else
    return $killpercentage;
}

// This function prints a table showing a players achievements regarding all bodyparts,
// both in hitting and being hit
function player_bodyparts($playerid, $dbID = false)
{

  $link = baselink();
    
  global $coddb;
  global $separatorline;
  global $t; // table names from config
  global $b; // bodypart names from config
  
echo "<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\" class=\"outertable\"><tr><td align=\"center\">Hitzones</td></tr><tr><td>
<table width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"0\" class=\"innertable\">
  <tr class=\"outertable\">
    <td>Bodypart</td>
    <td colspan=\"2\" align=\"center\">Kills</td>
    <td colspan=\"2\" align=\"center\">Deaths</td>
<!--    <td colspan=\"2\" align=\"center\">Suicides</td> -->
<!--    <td colspan=\"2\" align=\"center\">Team Kills</td> -->
<!--    <td colspan=\"2\" align=\"center\">Team Deaths</td> -->
  ";

  if($dbID == false)
  {
  $query = "SELECT id, kills, deaths, suicides, teamkills, teamdeaths 
            FROM ${t['players']}
            WHERE id = $playerid AND hide = 0
            LIMIT 1";
  }
  else 
  {
  $query = "SELECT id, kills, deaths, suicides, teamkills, teamdeaths 
            FROM ${t['players']}
            WHERE client_id = $playerid AND hide = 0
            LIMIT 1";
  }
  $result = $coddb->sql_query($query);
  $row = $coddb->sql_fetchrow($result);
  
  $playerid =  $row['id'];
  $kills = $row['kills'];
  $deaths = $row['deaths'];
  $suicides = $row['suicides'];
  $teamkills = $row['teamkills'];
  $teamdeaths = $row['teamdeaths'];
  
  $query = "SELECT ${t['bodyparts']}.name, ${t['playerbody']}.kills, 
                ${t['playerbody']}.deaths, ${t['playerbody']}.suicides, 
                ${t['playerbody']}.teamkills, ${t['playerbody']}.teamdeaths
            FROM ${t['bodyparts']}, ${t['playerbody']}
            WHERE ${t['playerbody']}.player_id = $playerid
                AND ${t['bodyparts']}.id = ${t['playerbody']}.bodypart_id
            ORDER BY ${t['playerbody']}.kills DESC";
  

  $result = $coddb->sql_query($query);
  while ($row = $coddb->sql_fetchrow($result))
  {
  if ($separatorline == 1)
    echo "<tr><td colspan=\"11\" class=\"outertable\"><img src=\"/images/spacer.gif\" width=\"1\" height=\"1\" alt=\"\"></td></tr>";  // This draws a one pixel line between rows
    echo "<tr>";
    if (isset($b[$row['name']]))
      echo "  <td>".$b[ $row['name'] ]."</td>";
    else
      echo "  <td>${row['name']}</td>";
    echo "  <td align=\"center\">", $row['kills'] ? $row['kills'] : "", "</td>";
    if ( ($kills > 0) && ($row['kills'] > 0) )
    {
      $temp = sprintf("%.2f", 100*$row['kills']/$kills);
      echo "  <td align=\"center\" class=\"tiny\">($temp%)</td>";   
    }
    else
      echo "  <td></td>";
    echo "  <td align=\"center\">", $row['deaths'] ? $row['deaths'] : "", "</td>";
    if ( ($deaths > 0) && ($row['deaths'] > 0) )
    {
      $temp = sprintf("%.2f", 100*$row['deaths']/$deaths);
      echo "  <td align=\"center\" class=\"tiny\">($temp%)</td>";   
    }
    else
      echo "  <td></td>";
    echo "</tr>";
  }
  echo "</table>";
  echo "</td></tr><tr><td class=\"tiny\" align =\"right\">Watch your cover and aim for deadly hitzones on your opponents!";
  echo "</td></tr></table>";                                                                // Closing extra border-table
}


// This function shows a players achievements in the maps he's played
function player_maps_s($playerid, $dbID = false)
{
  $Output = "";
  $link = baselink();
  global $coddb;
  global $separatorline;
    
  global $t; // table names from config
  global $m; // map names from config
    //<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\" class=\"outertable\"><tr><td align=\"center\">Map achievements</td></tr><tr><td>
  $Output = "
    <table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\" class=\"outertable\"><tr><td>
        <table width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"0\" class=\"innertable\">
            <tr class=\"outertable\">
                <td>Map</td>
                <td>Rounds</td>
                <td colspan=\"2\" align=\"center\">Kills</td>
                <td colspan=\"2\" align=\"center\">Deaths</td>
                <td colspan=\"2\" align=\"center\">Suicides</td>
                <td colspan=\"2\" align=\"center\">Team Kills</td>
                <td colspan=\"2\" align=\"center\">Team Deaths</td>
                ";

    if($dbID == false)
    {
  $query = "SELECT id, kills, deaths, suicides, teamkills, teamdeaths 
            FROM ${t['players']}
            WHERE id = $playerid AND hide = 0
            LIMIT 1";
    }
    else 
    {
  $query = "SELECT id, kills, deaths, suicides, teamkills, teamdeaths 
            FROM ${t['players']}
            WHERE client_id = $playerid AND hide = 0
            LIMIT 1";
}
  $result = $coddb->sql_query($query);
  $row = $coddb->sql_fetchrow($result);
  if ($row == false) 
      return;  // no result given: does not exist or is hidden. Anyway, return whence thou camest!
  
  $playerid =  $row['id'];
  $kills = $row['kills'];
  $deaths = $row['deaths'];
  $suicides = $row['suicides'];
  $teamkills = $row['teamkills'];
  $teamdeaths = $row['teamdeaths'];
  
  $query = "SELECT ${t['maps']}.name, ${t['maps']}.id, ${t['playermaps']}.kills, 
                ${t['playermaps']}.deaths, ${t['playermaps']}.suicides, 
                ${t['playermaps']}.teamkills, ${t['playermaps']}.teamdeaths,
                ${t['playermaps']}.rounds
            FROM ${t['maps']}, ${t['playermaps']}
            WHERE ${t['playermaps']}.player_id = $playerid
                AND ${t['maps']}.id = ${t['playermaps']}.map_id
            ORDER BY ${t['playermaps']}.kills DESC";
  $result = $coddb->sql_query($query);
  while ($row = $coddb->sql_fetchrow($result))
  {
  if ($separatorline == 1)
    $Output .= "<tr><td colspan=\"12\" class=\"outertable\"><img src=\"/images/spacer.gif\" width=\"1\" height=\"1\" alt=\"\"></td></tr>
    ";  // This draws a one pixel line between rows
    $Output .= "<tr>
    ";

    if (isset($m[$row['name']]))
    {
      $Output .= "<td><a href=\"$link?func=map&mapid=${row['id']}\">".$m[ $row['name'] ]."</a></td>
      ";
    }
    else
    {
      $Output .= "<td><a href=\"$link?func=map&mapid=${row['id']}\">${row['name']}</a></td>
      ";
    }

    $Output .= "  <td align=\"center\">";
    if($row['rounds'] == "")
    {
      $Output .= "</td>
      ";    
    }
    else
    {
      $Output .= $row['rounds']."</td>
      "; 
    }
    
    $Output .= "  <td align=\"center\">";
    if($row['kills'] == "")
    {
      $Output .= "</td>
      ";    
    }
    else
    {
      $Output .= $row['kills']."</td>
      "; 
    }
        
    if ( ($kills > 0) && ($row['kills'] > 0) )
    {
      $temp = sprintf("%.2f", 100*$row['kills']/$kills);
      $Output .= "  <td align=\"center\" class=\"tiny\">($temp%)</td>
      ";   
    }
    else
    {
     $Output .= "  <td></td>
     ";
    }

    $Output .= "  <td align=\"center\">";
    if($row['deaths'] == "")
    {
      $Output .= "</td>
      ";    
    }
    else
    {
      $Output .= $row['deaths']."</td>
      "; 
    }
     
    if ( ($deaths > 0) && ($row['deaths'] > 0) )
    {
      $temp = sprintf("%.2f", 100*$row['deaths']/$deaths);
      $Output .= "  <td align=\"center\" class=\"tiny\">($temp%)</td>
      ";   
    }
    else
    {
      $Output .= "  <td></td>
      ";
    }
    
    $Output .= "  <td align=\"center\">";
    if($row['suicides'] == "")
    {
      $Output .= "</td>
      ";    
    }
    else
    {
      $Output .= $row['suicides']."</td>
      "; 
    }
    
    if ( ($suicides > 0) && ( $row['suicides'] > 0) )
    {
      $temp = sprintf("%.2f", 100*$row['suicides']/$suicides);
      $Output .=  "  <td align=\"center\" class=\"tiny\">($temp%)</td>
      ";   
    }
    else
    {
      $Output .= "  <td></td>
      ";
    }
    
    $Output .= "  <td align=\"center\">";
    if($row['teamkills'] == "")
    {
      $Output .= "</td>
      ";    
    }
    else
    {
      $Output .= $row['teamkills']."</td>
      "; 
    }
    
    if ( ($teamkills > 0) && ($row['teamkills'] > 0) )
    {
      $temp = sprintf("%.2f", 100*$row['teamkills']/$teamkills);
      $Output .= "  <td align=\"center\" class=\"tiny\">($temp%)</td>
      ";   
    }
    else
    {
      $Output .= "  <td></td>
      ";
    }
    $Output .= "  <td align=\"center\">";
    if($row['teamdeaths'] == "")
    {
      $Output .= "</td>
      ";    
    }
    else
    {
      $Output .= $row['teamdeaths']."</td>
      "; 
    }
    
    if ( ($teamdeaths > 0) && ( $row['teamdeaths'] > 0 ) )
    {
      $temp = sprintf("%.2f", 100*$row['teamdeaths']/$teamdeaths);
      $Output .=  "  <td align=\"center\" class=\"tiny\">($temp%)</td>
      ";   
    }
    else
    {
      $Output .=  "  <td></td>
      ";
    }
    $Output .=  "</tr>
    ";
  }
  $Output .=  "</table>";
  $Output .=  "</td></tr><tr><td class=\"tiny\" align =\"right\">Click the mapname to see who does well on this map";
  $Output .=  "</td></tr></table>";       
  return $Output;                                                         // Closing extra border-table
}

// This function shows a players achievements in the maps he's played
function player_maps($playerid, $dbID = false)
{

  $link = baselink();
  global $coddb;
  global $separatorline;
    
  global $t; // table names from config
  global $m; // bodypart names from config
  
echo "<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\" class=\"outertable\"><tr><td align=\"center\">Map achievements</td></tr><tr><td>
      <table width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"0\" class=\"innertable\">
        <tr class=\"outertable\">
          <td>Map</td>
          <td>Rounds</td>
          <td colspan=\"2\" align=\"center\">Kills</td>
          <td colspan=\"2\" align=\"center\">Deaths</td>
          <td colspan=\"2\" align=\"center\">Suicides</td>
          <td colspan=\"2\" align=\"center\">Team Kills</td>
          <td colspan=\"2\" align=\"center\">Team Deaths</td>
    ";
  if($dbID == false)
  {
  $query = "SELECT id, kills, deaths, suicides, teamkills, teamdeaths 
            FROM ${t['players']}
            WHERE id = $playerid AND hide = 0
            LIMIT 1";
  }
  else 
  {
  $query = "SELECT id, kills, deaths, suicides, teamkills, teamdeaths 
            FROM ${t['players']}
            WHERE client_id = $playerid AND hide = 0
            LIMIT 1";
}
  $result = $coddb->sql_query($query);
  $row = $coddb->sql_fetchrow($result);
  if ($row == false) 
    return;  // no result given: does not exist or is hidden. Anyway, return whence thou camest!
  
  $playerid =  $row['id'];
  $kills = $row['kills'];
  $deaths = $row['deaths'];
  $suicides = $row['suicides'];
  $teamkills = $row['teamkills'];
  $teamdeaths = $row['teamdeaths'];
  
  $query = "SELECT ${t['maps']}.name, ${t['maps']}.id, ${t['playermaps']}.kills, 
                ${t['playermaps']}.deaths, ${t['playermaps']}.suicides, 
                ${t['playermaps']}.teamkills, ${t['playermaps']}.teamdeaths,
                ${t['playermaps']}.rounds
            FROM ${t['maps']}, ${t['playermaps']}
            WHERE ${t['playermaps']}.player_id = $playerid
                AND ${t['maps']}.id = ${t['playermaps']}.map_id
            ORDER BY ${t['playermaps']}.kills DESC";
  $result = $coddb->sql_query($query);
  while ($row = $coddb->sql_fetchrow($result))
  {
  if ($separatorline == 1)
    echo "<tr><td colspan=\"12\" class=\"outertable\"><img src=\"/images/spacer.gif\" width=\"1\" height=\"1\" alt=\"\"></td></tr>";  // This draws a one pixel line between rows
    echo "<tr>";

    if (isset($m[$row['name']]))
      echo "<td><a href=\"$link?func=map&mapid=${row['id']}\">".$m[ $row['name'] ]."</a></td>";
    else
      echo "<td><a href=\"$link?func=map&mapid=${row['id']}\">${row['name']}</a></td>";

    echo "  <td align=\"center\">", $row['rounds'] ? $row['rounds'] : "", "</td>";
    echo "  <td align=\"center\">", $row['kills'] ? $row['kills'] : "", "</td>";
    if ( ($kills > 0) && ($row['kills'] > 0) )
    {
      $temp = sprintf("%.2f", 100*$row['kills']/$kills);
      echo "  <td align=\"center\" class=\"tiny\">($temp%)</td>";   
    }
    else
      echo "  <td></td>";
    echo "  <td align=\"center\">", $row['deaths'] ? $row['deaths'] : "", "</td>";
    if ( ($deaths > 0) && ($row['deaths'] > 0) )
    {
      $temp = sprintf("%.2f", 100*$row['deaths']/$deaths);
      echo "  <td align=\"center\" class=\"tiny\">($temp%)</td>";   
    }
    else
      echo "  <td></td>";
    echo "  <td align=\"center\">", $row['suicides'] ? $row['suicides'] : "", "</td>";
    if ( ($suicides > 0) && ( $row['suicides'] > 0) )
    {
      $temp = sprintf("%.2f", 100*$row['suicides']/$suicides);
      echo "  <td align=\"center\" class=\"tiny\">($temp%)</td>";   
    }
    else
      echo "  <td></td>    ";
    echo "  <td align=\"center\">", $row['teamkills'] ? $row['teamkills'] : "", "</td>";
    if ( ($teamkills > 0) && ($row['teamkills'] > 0) )
    {
      $temp = sprintf("%.2f", 100*$row['teamkills']/$teamkills);
      echo "  <td align=\"center\" class=\"tiny\">($temp%)</td>";   
    }
    else
      echo "  <td></td>";
    echo "  <td align=\"center\">", $row['teamdeaths'] ? $row['teamdeaths'] : "", "</td>";
    if ( ($teamdeaths > 0) && ( $row['teamdeaths'] > 0 ) )
    {
      $temp = sprintf("%.2f", 100*$row['teamdeaths']/$teamdeaths);
      echo "  <td align=\"center\" class=\"tiny\">($temp%)</td>";   
    }
    else
      echo "  <td></td>";
    echo "</tr>";
  }
  echo "</table>";
  echo "</td></tr><tr><td class=\"tiny\" align =\"right\">Click the mapname to see who does well on this map";
  echo "</td></tr></table>";                                                                // Closing extra border-table
}

// This functions shows who a player has hit, and whom he was hit by
function player_opponents_s($playerid, $dbID = false)
{
  $Output = "";  
  $link = baselink();

  global $coddb;
  global $separatorline;
  global $t; // table names from config
  global $enemies_max;
  global $playername;

  $Output = "
  <table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\" class=\"outertable\"><tr><td>
    <table width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"0\" class=\"innertable\">
        <tr class=\"outertable\">
            <td>Your worst enemies</td>
            <td colspan=\"2\" align=\"center\">Your Deaths</td>
            <td colspan=\"2\" align=\"center\">Your Kills</td>
            <td align=\"center\">Your K/D Ratio</td>
            ";
    
    if($dbID == false)
    {
      $query = "SELECT id, kills, deaths 
                FROM ${t['players']}
                WHERE id = $playerid AND hide = 0
                LIMIT 1";
    }
    else 
    {
      $query = "SELECT id, kills, deaths 
                FROM ${t['players']}
                WHERE client_id = $playerid AND hide = 0
                LIMIT 1";        
    }
 
    $result = $coddb->sql_query($query);
    $row = $coddb->sql_fetchrow($result);
    
    if ($row == false) 
      return;  // no result given: does not exist or is hidden. Anyway, return whence thou camest!
        
    $playerid =  $row['id'];
 
    $kills = $row['kills'];
    $deaths = $row['deaths'];
  
    $query = "SELECT ${t['opponents']}.target_id, ${t['opponents']}.kills,
                     ${t['opponents']}.retals, ${t['players']}.fixed_name,
                     ${t['b3_clients']}.name
              FROM ${t['opponents']},
                   ${t['players']},
                   ${t['b3_clients']}
              WHERE ${t['opponents']}.killer_id = $playerid
                   AND ${t['players']}.id = ${t['opponents']}.target_id
                   AND ${t['b3_clients']}.id = ${t['players']}.client_id
                   AND ${t['players']}.hide = 0 
              ORDER BY ${t['opponents']}.retals DESC
              LIMIT $enemies_max";

  $result = $coddb->sql_query($query);

  while ($row = $coddb->sql_fetchrow($result))
  {
    if ($separatorline == 1)
      {
      $Output .= "<tr><td colspan=\"6\" class=\"outertable\"><img src=\"/images/spacer.gif\" width=\"1\" height=\"1\" alt=\"\"></td></tr>
      ";  // This draws a one pixel line between rows
      }
    $Output .= "<tr>
    ";
    $Output .= "<td><a href=\"$link?func=player&playerid=${row['target_id']}\">
    ";//, $row['fixed_name'] ? $row['fixed_name'] : $row['name'], "</a></td>
    
    if($row['fixed_name'] == 0)
    {
      $Output .= $row['name'];
      $tempname = $row['name'];
    }
    else
    {
     $Output .= $row['fixed_name'];           
     $tempname = $row['fixed_name'];
    }
      
    $Output .= " </a></td>";
    $Output .= "  <td align=\"center\" title=\"$tempname killed you ${row['retals']} times.\">${row['retals']}</td>
    ";
    if ( ($deaths > 0) && ($row['retals'] > 0) )
    {
      $temp = sprintf("%.2f", 100*$row['retals']/$deaths);
      $Output .= "  <td align=\"center\" class=\"tiny\" title=\"$tempname is responsible for $temp% of your total deaths.\">($temp%)</td>
      ";   
    }
    else
    {
      $Output .= "  <td></td> 
      ";
    }
    $Output .= "   <td align=\"center\" title=\"You killed $tempname ${row['kills']} times.\">${row['kills']}</td>
    ";
    if ( ($kills > 0) && ($row['kills'] > 0) )
    {
      $temp = sprintf("%.2f", 100*$row['kills']/$kills);
      $Output .= "  <td align=\"center\" class=\"tiny\" title=\"$tempname makes $temp% of your total kills.\">($temp%)</td>
      ";   
    }
    else
    {
      $Output .= "  <td></td>
      ";
    }
    if ( $row['retals'] > 0)
    {
      $temp = sprintf("%.2f", $row['kills']/$row['retals']);
      if ($temp < 1) 
      {
        $Output .= "  <td class=\"attention\" align=\"center\" title=\"$tempname seems to be better than you!\">$temp</td>
        ";
      }
      else
      {
        $Output .= "  <td align=\"center\" title=\"You have a good K/D ratio on $tempname!\">$temp</td>
        ";
      } 
    }
    else
    {
      $Output .= "  <td></td>
      ";
    }
      
    $Output .= "</tr>
    ";
  }
  
  $Output .= "</table>
  ";
  $Output .= "</td></tr><tr><td class=\"tiny\" align =\"right\">Who's your worst enemy?
  ";
  $Output .= "</td></tr></table>
  ";     // Closing extra border-table
  
  return $Output;
}

// This functions shows who a player has hit, and whom he was hit by
function player_opponents($playerid, $dbID = false)
{

  $link = baselink();
  
  global $coddb;
  global $separatorline;
  global $t; // table names from config
  global $enemies_max;  

  echo "<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\" class=\"outertable\"><tr><td align=\"center\">Your worst enemies</td></tr><tr><td>
        <table width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"0\" class=\"innertable\">
          <tr class=\"outertable\">
            <td>Player</td>
            <td colspan=\"2\" align=\"center\">Kills</td>
            <td colspan=\"2\" align=\"center\">Deaths</td>
            <td align=\"center\">Ratio</td>
  ";

  if($dbID == false)
  {
  $query = "SELECT id, kills, deaths 
            FROM ${t['players']}
            WHERE id = $playerid AND hide = 0
            LIMIT 1";
  }
  else 
  {
  $query = "SELECT id, kills, deaths 
            FROM ${t['players']}
            WHERE client_id = $playerid AND hide = 0
            LIMIT 1";   
}
 
  $result = $coddb->sql_query($query);
  $row = $coddb->sql_fetchrow($result);
  if ($row == false) return;  // no result given: does not exist or is hidden. Anyway, return whence thou camest!
  $playerid =  $row['id'];
 
  $kills = $row['kills'];
  $deaths = $row['deaths'];
  
  $query = "SELECT ${t['opponents']}.target_id, ${t['opponents']}.kills,
                   ${t['opponents']}.retals, ${t['players']}.fixed_name,
                   ${t['b3_clients']}.name
            FROM ${t['opponents']},
                 ${t['players']},
                 ${t['b3_clients']}
            WHERE ${t['opponents']}.killer_id = $playerid
                 AND ${t['players']}.id = ${t['opponents']}.target_id
                 AND ${t['b3_clients']}.id = ${t['players']}.client_id
                 AND ${t['players']}.hide = 0 
            ORDER BY ${t['opponents']}.kills DESC
            LIMIT $enemies_max";

  $result = $coddb->sql_query($query);

  while ($row = $coddb->sql_fetchrow($result))
  {
    if ($separatorline == 1)
      echo "<tr><td colspan=\"6\" class=\"outertable\"><img src=\"/images/spacer.gif\" width=\"1\" height=\"1\" alt=\"\"></td></tr>";  // This draws a one pixel line between rows
    echo "<tr>";
    echo "<td><a href=\"$link?func=player&playerid=${row['target_id']}\">", $row['fixed_name'] ? $row['fixed_name'] : $row['name'], "</a></td>";
    echo "  <td align=\"center\">${row['kills']}</td>";
    if ( ($kills > 0) && ($row['kills'] > 0) )
    {
      $temp = sprintf("%.2f", 100*$row['kills']/$kills);
      echo "  <td align=\"center\" class=\"tiny\">($temp%)</td>";   
    }
    else
      echo "  <td></td>";
    echo "  <td align=\"center\">${row['retals']}</td>";
    if ( ($deaths > 0) && ($row['retals'] > 0) )
    {
      $temp = sprintf("%.2f", 100*$row['retals']/$deaths);
      echo "  <td align=\"center\" class=\"tiny\">($temp%)</td>";   
    }
    else
      echo "  <td></td>";
    if ( $row['retals'] > 0)
    {
      $temp = sprintf("%.2f", $row['kills']/$row['retals']);
      echo "  <td align=\"center\">$temp</td>"; 
    }
    else
      echo "  <td></td>";
      
    echo "</tr>";
  }
  
  echo "</table>";
  echo "</td></tr><tr><td class=\"tiny\" align =\"right\">Who's your worst enemy?";
  echo "</td></tr></table>";     // Closing extra border-table
}

//*****************************************************************************
//
//  Following are all weapon specific functions
//
//*****************************************************************************


// This function shows a summary of a weapons stats
function weapon_short($weaponid)
{

  $link = baselink();
    
  global $coddb;
  global $game;
  global $t; // table names from config
  global $w; // weapon aliases
 
  $query = "SELECT * 
            FROM ${t['weapons']}
            WHERE id = $weaponid
            LIMIT 1";

  $result = $coddb->sql_query($query);
  $row = $coddb->sql_fetchrow($result);

  echo "<table class=\"outertable\" width=\"100%\">";
  if (isset($w[$row['name']]))
    echo "  <tr><td colspan=\"3\" align=\"center\" valign=\"top\">".$w[ $row['name'] ]."</td></tr><tr class=\"innertable\"><td valign=\"top\" width=\"150\">";
  else
    echo "  <tr><td colspan=\"3\" align=\"center\" valign=\"top\">${row['name']}</td></tr><tr class=\"innertable\"><td valign=\"top\" width=\"150\">";
  echo "    <table width=\"150\">";
  echo "      <tr><td class=\"innertable\">Total Kills</td><td align=\"center\" class=\"innertable\">${row['kills']}</td></tr>";
  echo "      <tr><td class=\"innertable\">Total Team kills</td><td align=\"center\" class=\"innertable\">${row['teamkills']}</td></tr>";
  echo "      <tr><td class=\"innertable\">Total Suicides</td><td align=\"center\" class=\"innertable\">${row['suicides']}</td></tr>";
  echo "    </table>";
  echo "  </td><td width=\"50\" valign=\"top\">";
  // catch cod1, coduo and cod2 in one imagefolder
  if ($game == "cod1" && !file_exists("./images/weapons/cod1/"))
    $gamename = "cod2";
  elseif ($game == "coduo" && !file_exists("./images/weapons/coduo/"))
    $gamename = "cod2";
  else
    $gamename = $game;
  get_pic("./images/weapons/$gamename/normal/${row['name']}");
  echo "  </td><td valign=\"top\" class=\"tiny\">";
  get_desc("weapon/${row['name']}");
  echo "</td></tr>";
  echo "</table>";
}

// This function shows how a specific weapon was used by or against all players
function weapon_players($weaponid)
{

  $link = baselink();
  global $coddb;
  global $separatorline;
  global $t; // table names from config
  global $weap_minkills;
  
echo "<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\" class=\"outertable\"><tr><td align=\"center\">Playerstats for this weapon</td></tr><tr><td>
      <table width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"0\" class=\"innertable\">
        <tr class=\"outertable\">
          <td>Player</td>
          <td colspan=\"2\" align=\"center\">Kills</td>
          <td colspan=\"2\" align=\"center\">Deaths</td>
          <td colspan=\"2\" align=\"center\">Suicides</td>
          <td colspan=\"2\" align=\"center\">Team Kills</td>
          <td colspan=\"2\" align=\"center\">Team Deaths</td>
      ";

  $query = "SELECT kills, suicides, teamkills
            FROM ${t['weapons']}
            WHERE id = $weaponid
            LIMIT 1";

  $result = $coddb->sql_query($query);
  $row = $coddb->sql_fetchrow($result);
  
  $kills = $row['kills'];
  //$deaths = $row['deaths'];
  $suicides = $row['suicides'];
  $teamkills = $row['teamkills'];
  //$teamdeaths = $row['teamdeaths'];
    
  $query = "SELECT ${t['b3_clients']}.name, ${t['weaponusage']}.player_id, ${t['weaponusage']}.kills, 
                ${t['weaponusage']}.deaths, ${t['weaponusage']}.suicides, 
                ${t['weaponusage']}.teamkills, ${t['weaponusage']}.teamdeaths,
                ${t['players']}.fixed_name
            FROM ${t['b3_clients']}, ${t['players']}, ${t['weaponusage']}
            WHERE ${t['weaponusage']}.weapon_id = $weaponid
                AND ${t['players']}.id = ${t['weaponusage']}.player_id
                AND ${t['b3_clients']}.id = ${t['players']}.client_id
                AND (${t['weaponusage']}.kills > $weap_minkills
                    OR ${t['weaponusage']}.suicides > $weap_minkills)
                AND ${t['players']}.hide = 0
           ORDER BY ${t['weaponusage']}.kills DESC, ${t['weaponusage']}.suicides DESC";

  $result = $coddb->sql_query($query);
  while ($row = $coddb->sql_fetchrow($result))
  {
    if ($separatorline == 1)
      echo "<tr><td colspan=\"11\" class=\"outertable\"><img src=\"/images/spacer.gif\" width=\"1\" height=\"1\" alt=\"\"></td></tr>\n";  // This draws a one pixel line between rows
    echo "<tr>";
    echo "<td><a href=\"$link?func=player&playerid=${row['player_id']}\">", $row['fixed_name'] ? $row['fixed_name'] : $row['name'], "</a></td>";
    echo "  <td align=\"center\">", $row['kills'] ? $row['kills'] : "", "</td>";
    if ( ($kills > 0) && ($row['kills'] > 0) )
    {
      $temp = sprintf("%.2f", 100*$row['kills']/$kills);
      echo "  <td align=\"center\" class=\"tiny\">($temp%)</td>";   
    }
    else
      echo "  <td></td>";
    echo "  <td align=\"center\">", $row['deaths'] ? $row['deaths'] : "", "</td>";
    if ( ($kills > 0) && ($row['deaths'] > 0) )
    {
      $temp = sprintf("%.2f", 100*$row['deaths']/$kills);
      echo "  <td align=\"center\" class=\"tiny\">($temp%)</td>";   
    }
    else
      echo "  <td></td>";
    echo "  <td align=\"center\">", $row['suicides'] ? $row['suicides'] : "", "</td>";
    if ( ($suicides > 0) && ( $row['suicides'] > 0) )
    {
      $temp = sprintf("%.2f", 100*$row['suicides']/$suicides);
      echo "  <td align=\"center\" class=\"tiny\">($temp%)</td>";   
    }
    else
      echo "  <td></td>    ";
    echo "  <td align=\"center\">", $row['teamkills'] ? $row['teamkills'] : "", "</td>";
    if ( ($teamkills > 0) && ( $row['teamkills'] > 0) )
    {
      $temp = sprintf("%.2f", 100*$row['teamkills']/$teamkills);
      echo "  <td align=\"center\" class=\"tiny\">($temp%)</td>";   
    }
    else
      echo "  <td></td>";
    echo "  <td align=\"center\">", $row['teamdeaths'] ? $row['teamdeaths'] : "", "</td>";
    if ( ($teamkills > 0) && ( $row['teamdeaths'] > 0 ) )
    {
      $temp = sprintf("%.2f", 100*$row['teamdeaths']/$teamkills);
      echo "  <td align=\"center\" class=\"tiny\">($temp%)</td>";   
    }
    else
      echo "  <td></td>";
    echo "</tr>\n";
  }
  echo "</table>";
  echo "</td></tr><tr><td class=\"tiny\" align =\"right\">You need at least $weap_minkills kills/suicides with this weapon to appear on this list!";
  echo "</td></tr></table>";                                                                // Closing extra border-table
}

//******************************************************************************
//
//  Following are all map specific functions
//
//******************************************************************************

// This function gives a short overview about a specific map
function map_short($mapid)
{

  $link = baselink();
     
  global $coddb;
  global $game;
  global $separatorline;
  global $t; // table names from config
  global $m; // map aliases

  $query = "SELECT * 
            FROM ${t['maps']}
            WHERE id = $mapid
            LIMIT 1";

  $result = $coddb->sql_query($query);
  $row = $coddb->sql_fetchrow($result);

  echo "<table class=\"outertable\" width=\"100%\">";
  if (isset($m[$row['name']]))
    echo "  <tr><td colspan=\"3\" align=\"center\" valign=\"top\">".$m[ $row['name'] ]."</td></tr><tr class=\"innertable\"><td valign=\"top\" width=\"150\">";
  else
    echo "  <tr><td colspan=\"3\" align=\"center\" valign=\"top\">${row['name']}</td></tr><tr class=\"innertable\"><td valign=\"top\" width=\"150\">";
  echo "    <table width=\"150\">";
  echo "      <tr><td class=\"innertable\">Total Kills</td><td align=\"center\" class=\"innertable\">${row['kills']}</td></tr>";
  echo "      <tr><td class=\"innertable\">Total Team kills</td><td align=\"center\" class=\"innertable\">${row['teamkills']}</td></tr>";
  echo "      <tr><td class=\"innertable\">Total Suicides</td><td align=\"center\" class=\"innertable\">${row['suicides']}</td></tr>";
  echo "    </table>";
  echo "  </td><td width=\"50\" valign=\"top\">";

  // catch cod1, coduo and cod2 in one imagefolder
  if ($game == "cod1" && !file_exists("./images/maps/cod1/"))
    $gamename = "cod2";
  elseif ($game == "coduo" && !file_exists("./images/maps/coduo/"))
    $gamename = "cod2";
  else
    $gamename = $game;
  get_pic("./images/maps/$gamename/middle/${row['name']}");

  echo "  </td><td valign=\"top\" class=\"tiny\">";
  get_desc("map/${row['name']}");
  echo "  </td></tr>";
  echo "</table>";
}

// This function tells about the lives, kills & deaths of all players in a specific map
function map_players($mapid)
{
  $link = baselink();
  global $coddb;
  global $separatorline;
  global $t; // table names from config
  global $map_minkills;
  global $map_minrounds;
  
echo "<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\" class=\"outertable\"><tr><td align=\"center\">Playerstats for this map</td></tr><tr><td>
      <table width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"0\" class=\"innertable\">
        <tr class=\"outertable\">
          <td>Player</td>
          <td colspan=\"2\" align=\"center\">Kills</td>
          <td colspan=\"2\" align=\"center\">Suicides</td>
          <td colspan=\"2\" align=\"center\">Team Kills</td>
          <td align=\"center\">Rounds</td>
    ";

  $query = "SELECT kills, suicides, teamkills, rounds
            FROM ${t['maps']}
            WHERE id = $mapid
            LIMIT 1";

  $result = $coddb->sql_query($query);
  $row = $coddb->sql_fetchrow($result);
  
  $kills = $row['kills'];
//  $deaths = $row['deaths'];
  $suicides = $row['suicides'];
  $teamkills = $row['teamkills'];
  $rounds = $row['rounds'];
//  $teamdeaths = $row['teamdeaths'];
  
  $query = "SELECT ${t['b3_clients']}.name, ${t['playermaps']}.player_id, ${t['playermaps']}.kills, 
                ${t['playermaps']}.suicides, 
                ${t['playermaps']}.teamkills,
                ${t['playermaps']}.rounds,
                ${t['players']}.fixed_name
            FROM ${t['b3_clients']}, ${t['players']}, ${t['playermaps']}
            WHERE ${t['playermaps']}.map_id = $mapid
                AND ${t['players']}.id = ${t['playermaps']}.player_id
                AND ${t['players']}.hide = 0
                AND ${t['b3_clients']}.id = ${t['players']}.client_id
                AND ( ${t['playermaps']}.kills > $map_minkills
                     OR ${t['playermaps']}.rounds > $map_minrounds )
            ORDER BY ${t['playermaps']}.kills DESC";

    $result = $coddb->sql_query($query);
    while ($row = $coddb->sql_fetchrow($result))
    {
      if ($separatorline == 1)
        echo "<tr><td colspan=\"8\" class=\"outertable\"><img src=\"/images/spacer.gif\" width=\"1\" height=\"1\" alt=\"\"></td></tr>";  // This draws a one pixel line between rows
      echo "<tr>";
      echo "<td><a href=\"$link?func=player&playerid=${row['player_id']}\">", $row['fixed_name'] ? $row['fixed_name'] : $row['name'], "</a></td>";
      echo "  <td align=\"center\">", $row['kills'] ? $row['kills'] : "", "</td>";
      if ( ($kills > 0) && ($row['kills'] > 0) )
      {
        $temp = sprintf("%.2f", 100*$row['kills']/$kills);
        echo "  <td align=\"center\" class=\"tiny\">($temp%)</td>";   
      }
      else
        echo "  <td></td>";
      echo "  <td align=\"center\">", $row['suicides'] ? $row['suicides'] : "", "</td>";
      if ( ($suicides > 0) && ( $row['suicides'] > 0) )
      {
        $temp = sprintf("%.2f", 100*$row['suicides']/$suicides);
        echo "  <td align=\"center\" class=\"tiny\">($temp%)</td>";   
      }
      else
        echo "  <td></td>    ";
      echo "  <td align=\"center\">", $row['teamkills'] ? $row['teamkills'] : "", "</td>";
      if ( ($teamkills > 0) && ( $row['teamkills'] > 0) )
      {
        $temp = sprintf("%.2f", 100*$row['teamkills']/$teamkills);
        echo "  <td align=\"center\" class=\"tiny\">($temp%)</td>";   
      }
      else
        echo "  <td></td>";
      echo "  <td align=\"center\">", $row['rounds'] ? $row['rounds'] : "", "</td>";

      echo "</tr>";
    }
    echo "</table>";
    echo "</td></tr><tr><td class=\"tiny\" align =\"right\">You need at least $map_minrounds rounds or $map_minkills kills on this map to appear on this list!";
    echo "</td></tr></table>";    // Closing extra border-table
}

function player_rank($playerid, $dbID)
{
  $link = baselink();
  global $coddb;
  global $separatorline;
  global $t; // table names from config
  global $map_minkills;
  global $map_minrounds;

  if($dbID == false)
  {
    $query = "SELECT id, kills, deaths 
              FROM ${t['players']}
              WHERE id = $playerid AND hide = 0
              LIMIT 1";
  }
  else 
  {
    $query = "SELECT id, kills, deaths 
              FROM ${t['players']}
              WHERE client_id = $playerid AND hide = 0
              LIMIT 1";        
  }
  
  $result = $coddb->sql_query($query);
  $row = $coddb->sql_fetchrow($result);
  if ($row == false) return;  // no result given: does not exist or is hidden. Anyway, return whence thou camest!
    $playerid =  $row['id'];

  $kills = $row['kills'];
  $deaths = $row['deaths'];
}
?>
