<?php
session_start();

require_once("../func-globallogic.php");
// If statsconfig.php exists, we won't enable multiconfig functionality
if (file_exists("../config/statsconfig.php"))
{
  $currentconfig = "../config/statsconfig.php";
  $currentconfignumber = 0;
}
elseif (file_exists("../config/statsconfig1.php"))
{
  $currentconfig = "../config/statsconfig1.php";
  $currentconfignumber = 1;
  // Was a config set in the url?
  if (isset($_GET['config'])) 
  {
    $currentconfignumber = escape_string($_GET['config']);
    $currentconfig = "../config/statsconfig".$currentconfignumber.".php";
    $_SESSION['../currentconfignumber'] = $currentconfignumber;
  }
  if (isset($_SESSION['currentconfignumber']))
  {
    $currentconfignumber = $_SESSION['currentconfignumber'];
    $currentconfig = "../config/statsconfig".$currentconfignumber.".php";
  }
}
require_once($currentconfig);

include( "settings.php" );
include( "sanity.php" );
error_reporting( E_ERROR ^ E_WARNING ); // Dont tell this noob about all our bugz!!!

// VARS
$player_id = 0;
$width = 0;
$height = 0;
$backdrop_url = "";
$color_scheme_id = 0;
$current_time = time();
$timelimit = $maxdays*60*60*24;

// REQUIRED INPUT
if( !isset($_GET['id']) )	die( "ID not specified." );
$player_id  = $_GET['id'];

// OPTIONAL INPUT
$backdrop_url = $_GET['b'];

$style_options = split("-", $_GET['s'] );
foreach( $style_options as $opt )
{
	if( $opt{0} == "c" ) $color_scheme_id = substr($opt,1);
	if( $opt{0} == "w" ) $width = substr($opt,1);
	if( $opt{0} == "h" ) $height = substr($opt,1);
}

// DATABASE
$db = mysql_connect( DB_HOST, DB_USER, DB_PASS ) or die( "Unable to connect to database server " . DB_HOST . "." );
mysql_select_db( DB_NAME, $db ) or die( "Unable to select database named " . DB_NAME . " ." );

$query = "SELECT * 
          FROM ${t['players']}, ${t['b3_clients']} 
          WHERE ${t['b3_clients']}.id = ${t['players']}.client_id 
              AND ${t['players']}.id = '" . addslashes_gpc($player_id) . "'
              AND ((${t['players']}.kills > $minkills)
                  OR (${t['players']}.rounds > $minrounds))
              AND (${t['players']}.hide = 0)
              AND ($current_time - ${t['b3_clients']}.time_edit  < $timelimit)";

$result = mysql_query( $query, $db ) or die( "Query Error:\n" . $query );

$player = mysql_fetch_assoc( $result );
mysql_free_result( $result );

$query = "SELECT count(*) AS rank
          FROM ${t['players']}, ${t['b3_clients']}
          WHERE ${t['b3_clients']}.id = ${t['players']}.client_id
              AND ${t['players']}.skill > " . $player['skill'] . " 
              AND ((${t['players']}.kills > $minkills)
                  OR (${t['players']}.rounds > $minrounds))
              AND (${t['players']}.hide = 0)
              AND ($current_time - ${t['b3_clients']}.time_edit  < $timelimit)";
$result = mysql_query( $query, $db ) or die( "Query Error:\n" . $query );

$row = mysql_fetch_assoc( $result );
//$player['rank'] = $row['rank'];
$player['rank'] = ++$row['rank'];

mysql_free_result( $result );
mysql_close( $db );


// TEMPLATE
include( "render.php" );

// OUTPUT
ob_start();
header( "Cache-Control: no-cache, must-revalidate" );
header( "Content-Type: image/jpeg" );
imagejpeg( $image, "", 100 );
imagedestroy( $image );
ob_end_flush();


// UTILITY FUNCTIONS

// This function is likly to fuck up at every available oppertunity!
function get_user_image( $image_url, $width, $height, $cache_life )
{
	$image = false; 
	$cached_files = array();
	$flag_cached = false;
	$flag_outdated = false;
	$flag_downloaded = false;
	$flag_unlinkerr = false;
	
	$image_hash = md5( $image_url );
	$hash_len = strlen( $image_hash );

	// Find cached copys of this remote file.
	$dir = opendir( CACHE_PATH );
	while( $file = readdir($dir) )
	{
		if( strncmp($file, $image_hash, $hash_len-1) == 0 )
		{
			$cached_file = $file;
			$flag_cached = true;
			
			// Get timestamp.		
			list( , $cache_time ) = split( "_", $cached_file );
			$cache_time = intval($cache_time);
			
			// Is this cached file out of date?
			if( $cache_time != 0 && $cache_time < (time() - (60*$cache_life)) )
				$flag_outdated = true;
				
			break;
		}
	}
	closedir($dir);
	
	// Force recache?
	$flag_recache = (isset($_GET['recache']) && $_SERVER['HTTP_REFERER'] == "") ? true:false;
		
	// Attempt to get the remote image and cache it.
	if( !$flag_cached || $flag_outdated || $flag_recache )
	{ 
		$file_in = @fopen( $image_url, "r" );
		if( $file_in ) 
		{
			while( !feof($file_in) )
			{	
				if( strlen($image_data) > IMAGE_MAX_SIZE ){	fclose( $file_in );	die( "Abuse detected." );	}
				$image_data .= fread( $file_in, 40000 );
			}
			fclose( $file_in );
			
			if( ($image = @imagecreatefromstring($image_data)) != false ) $flag_downloaded = true;			
		}
	}
			
	if( $flag_downloaded )
	{
		if( $flag_cached )
			$flag_unlinkerr != @unlink( CACHE_PATH . $cached_file );
			
		if( !$flag_unlinkerr )
			imagejpeg( $image, CACHE_PATH . $image_hash . "_" . (($cache_life) ? time() : "0000000000") . ".jpg", 100 );		
	}
	else if( $flag_cached )
	{
		// We have a local cached file and we didnt get a new one... rename it
		$image = @imagecreatefromjpeg( CACHE_PATH . $cached_file );
		if( $flag_outdated ) 
		{ 
			$old_name = CACHE_PATH . $cached_file;
			$new_name = CACHE_PATH . $image_hash . "_" . time() . ".jpg";
			@rename( $old_name, $new_name );
		}				
	}
	
	// Whaaa???
	if( $image == false ) die( "Unable to get image." );
	
	$image_width = imagesx( $image );
	$image_height = imagesy( $image );
	$resized_image = imagecreatetruecolor( $width, $height );
	imagecopyresampled( $resized_image, $image, 0, 0, 0, 0, $width, $height, $image_width, $image_height ); 		
	imagedestroy( $image );
	return $resized_image;
}

// Selects an image at random from the backdrop folder and resizes it to our desired dimensions.
function get_stock_backdrop( $width, $height )
{
	// If a user_template hasnt been set, set one at random.
	$dir = opendir( BACKDROP_FOLDER );
	if( !$dir )	die( "Unable to open backdrop folder, please ensure this folder exists and is writable." );
	while( $file = readdir($dir) )
	{
		if( $file{0} != "." )
			$backdrops[] = $file;
	}
	closedir($dir);
			
	$backdrop_file = BACKDROP_FOLDER . $backdrops[ rand(0,count($backdrops)-1) ];
	if( $width != 0 && $height != 0 )
	{
		$image = imagecreatetruecolor( $width, $height );
		$bd = imagecreatefromjpeg( $backdrop_file );
		imagecopyresampled( $image, $bd, 0, 0, 0, 0, $width, $height, imagesx($bd), imagesy($bd) );
		imagedestroy($bd);
		return $image;
	}
		
	return imagecreatefromjpeg( $backdrop_file );		
}

function write_line( $image, $size, $angle, &$x, &$y, $color, $font, $text, $spacing )
{
	$font_box = imagettfbbox( $size, 0, $font, "H" );
	$font_height = $font_box[1] - $font_box[7];
	imagettftext( $image, $size, 0, $x, $y, $color, $font, $text  );
	$y += $font_height + $spacing;
}

function get_text_metrics( $font, $size, $angle, $text )
{
	$bbox = imagettfbbox( $size, $angle, $font, $text );
	$w = $bbox[2]+$bbox[6];
	$h = $bbox[3]+$bbox[7];
	
	return array( $w, $h );
}

// MQ aware slashing functions for GPC inputs
function addslashes_gpc( $data )
{
	if( !get_magic_quotes_gpc() )
		return addslashes( $data );
	return $data;
}

function stripslashes_gpc( $data )
{
	if( get_magic_quotes_gpc() )
		return stripslashes( $data );
	return $data;
}
?>
